Imports System.Math
Public Class frmDesenfumage
    Dim Classe, Regle, NbExu, Nbcanton As Integer
    Dim Hr, Hl, S, Sue, alpha, Ef, Slibre, K As Double
    Dim R200 As Boolean

#Region "Gestion des TextBox"
    Private Sub Texthr_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHr.Enter
        TextHr.SelectionStart = 0
        TextHr.SelectionLength = TextHr.Text.Length
    End Sub
    Private Sub Texthr_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHr.KeyPress
        Call Gestion_Keypress(e, TextHr)
    End Sub
    Private Sub Texthl_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextHr.Enter
        TextHl.SelectionStart = 0
        TextHl.SelectionLength = TextHl.Text.Length
    End Sub
    Private Sub Texthl_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextHl.KeyPress
        Call Gestion_Keypress(e, TextHl)
    End Sub
    Private Sub Texts_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextS.Enter
        TextS.SelectionStart = 0
        TextS.SelectionLength = TextS.Text.Length
    End Sub
    Private Sub Texts_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextS.KeyPress
        Call Gestion_Keypress(e, TextS)
    End Sub
    Private Sub Textk_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextK.Enter
        TextK.SelectionStart = 0
        TextK.SelectionLength = TextK.Text.Length
    End Sub
    Private Sub Texthk_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextK.KeyPress
        Call Gestion_Keypress(e, TextK)
    End Sub
#End Region

    Private Sub BtnCalcul_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCalcul.Click
        Dim Verif As Boolean = True
        Call Lecture(Verif)
        If Verif = False Then Text1.Text = "" : Exit Sub
        Call Verification_generale(Verif)
        If Verif = False Then Text1.Text = "" : Exit Sub
        Call Calcul()
        Call Affichage()
    End Sub
    Private Sub Lecture(ByVal verif As Boolean)
        Dim msg As String
        If TextHr.Text = "" Then
            msg = "Vous avez oubli d'indiquer la hauteur de rfrence"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            verif = False : Exit Sub
        Else
            Hr = CDbl(TextHr.Text)
        End If
        If TextHl.Text = "" Then
            msg = "Vous avez oubli d'indiquer la hauteur libre"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            verif = False : Exit Sub
        Else
            Hl = CDbl(TextHl.Text)
        End If
        If TextS.Text = "" Then
            msg = "Vous avez oubli d'indiquer la surface du canton"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            verif = False : Exit Sub
        Else
            S = CDbl(TextS.Text)
        End If
        'Classe du local
        If Rbtn1.Checked = True Then Classe = 1
        If Rbtn2.Checked = True Then Classe = 2
        If Rbtn3.Checked = True Then Classe = 3
        'Rgle de calcul utilis
        If RbtnR1.Checked = True Then Regle = 1
        If RbtnR2.Checked = True Then Regle = 2
        'Exutoires utiliss
        If RbtnExu03.Checked = True Then k = 0.3
        If RbtnExu08.Checked = True Then
            If TextK.Text = "" Then
                msg = "Vous avez oubli d'indiquer le coefficient d'efficacit de l'exutoire"
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
                verif = False : Exit Sub
            Else
                k = CDbl(TextK.Text)
            End If
        End If
    End Sub
    Private Sub Verification_generale(ByVal verif As Boolean)
        Dim msg As String
        If Hl < Hr / 2 Then
            msg = "La hauteur libre de fume doit tre suprieure " & vbCrLf & _
            " la moiti de la hauteur de rfrence"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            verif = False : Exit Sub
        End If
        If Hl < 1.8 Then
            msg = "La hauteur libre de fume doit tre suprieure 1,80m." 
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            verif = False : Exit Sub
        End If
        If Hl < 2.04 Then
            msg = "La hauteur libre de fume doit tre plus haute que le linteau des portes." & vbCrLf & _
            "A contler sur votre projet"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End If
        If Hr > 8 Then
            If (Hr - Hl) < 2 Then
                msg = "L'paisseur de fume doit tre suprieure 2m " & vbCrLf & _
            "quand la hauteur de rfrence dpasse 8m."
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
                verif = False : Exit Sub
            End If
        Else
            If (Hr - Hl) < 0.25 * Hr Then
                Dim F As String
                F = Format(0.25 * Hr, "00.0##")
                msg = "L'paisseur de fume doit tre suprieure ou gale  " & F & " m" & vbCrLf & _
            "quand la hauteur de rfrence est infrieure ou gale  8m."
                MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
                verif = False : Exit Sub
            End If
        End If
    End Sub
    Private Sub Calcul()
        Dim Af, alpha1, alpha2, D, Sue1, Sue2, nb As Double

        Ef = 0 : alpha = 0
        Ef = Hr - Hl
        If Ef > Hr / 2 Then Ef = Hr / 2
        Select Case Regle
            Case 1
                'Calcul pour locaux de superficie infrieure ou gale  1000m
                Sue1 = S / 200
                'ou calcul suivant avec rgle S>1000m en prenant S=1000
                Select Case Classe
                    Case 1
                        Af = 9
                        D = Sqrt(4 * Af / PI)
                        If Hl > 2 * D Then
                            'formule petit feu
                            alpha2 = (0.043 * (Hr + 1.5 * Sqrt(Af) - Ef) ^ 2.5) / (16 * Sqrt(Ef))
                            alpha = alpha2
                        Else
                            'formule grand feu
                            alpha1 = (0.13 * 4 * Sqrt(Af) * Sqrt((Hr - Ef) ^ 3) * 0.6) / (16 * Sqrt(Ef))
                            alpha = alpha1
                        End If
                    Case 2
                        Af = 18
                        D = Sqrt(4 * Af / PI)
                        If Hl > 2 * D Then
                            'formule petit feu
                            alpha2 = (0.043 * (Hr + 1.5 * Sqrt(Af) - Ef) ^ 2.5) / (16 * Sqrt(Ef))
                            alpha = alpha2
                        Else
                            'formule grand feu
                            alpha1 = (0.13 * 4 * Sqrt(Af) * Sqrt((Hr - Ef) ^ 3) * 0.6) / (16 * Sqrt(Ef))
                            alpha = alpha1
                        End If
                    Case 3
                        Af = 36
                        D = Sqrt(4 * Af / PI)
                        'formule grand feu
                        alpha1 = (0.13 * 4 * Sqrt(Af) * Sqrt((Hr - Ef) ^ 3) * 0.6) / (16 * Sqrt(Ef))
                        alpha = alpha1
                End Select
                Sue2 = (alpha * 1000) / 100
                If Sue1 < Sue2 Then
                    Sue = Sue1 : R200 = True
                Else
                    Sue = Sue2 : R200 = False
                End If
            Case 2
                'Calcul pour locaux de superficie suprieure  1000m
                Select Case Classe
                    Case 1
                        Af = 9
                        D = Sqrt(4 * Af / PI)
                        If Hl > 2 * D Then
                            'formule petit feu
                            alpha2 = (0.043 * (Hr + 1.5 * Sqrt(Af) - Ef) ^ 2.5) / (16 * Sqrt(Ef))
                            alpha = alpha2
                        Else
                            'formule grand feu
                            alpha1 = (0.13 * 4 * Sqrt(Af) * Sqrt((Hr - Ef) ^ 3) * 0.6) / (16 * Sqrt(Ef))
                            alpha = alpha1
                        End If
                    Case 2
                        Af = 18
                        D = Sqrt(4 * Af / PI)
                        If Hl > 2 * D Then
                            'formule petit feu
                            alpha2 = (0.043 * (Hr + 1.5 * Sqrt(Af) - Ef) ^ 2.5) / (16 * Sqrt(Ef))
                            alpha = alpha2
                        Else
                            'formule grand feu
                            alpha1 = (0.13 * 4 * Sqrt(Af) * Sqrt((Hr - Ef) ^ 3) * 0.6) / (16 * Sqrt(Ef))
                            alpha = alpha1
                        End If
                    Case 3
                        Af = 36
                        D = Sqrt(4 * Af / PI)
                        'formule grand feu
                        alpha1 = (0.13 * 4 * Sqrt(Af) * Sqrt((Hr - Ef) ^ 3) * 0.6) / (16 * Sqrt(Ef))
                        alpha = alpha1
                End Select
                Sue = (alpha * S) / 100
        End Select
        nb = (S / 300)
        If nb = (Int(S / 300)) Then
            NbExu = CInt(Int(S / 300))
        Else
            NbExu = CInt(Int(S / 300)) + 1
        End If
        'calcul de la surface libre d'exutoire avec coefficient araulique
        Slibre = Sue / k
    End Sub
    Private Sub Affichage()
        Dim pp, p(10), F_alpha, F_sue, F_ef, F_nbexu, F_Slibre, F_k As String
        F_alpha = Format(alpha, "0.0##") : F_sue = Format(Sue, "##0.00#") : F_ef = Format(Ef, "##.00#")
        F_nbexu = Format(NbExu, "###") : F_Slibre = Format(Slibre, "##0.00#") : F_k = Format(K, "0.00#")
        p(1) = "La surface utile totale d'exutoire est de " & F_sue & " m"
        p(2) = "Le nombre total minimal d'exutoire est de " & F_nbexu & " (1 exutoire pour 300 m)"
        p(3) = "L'paisseur des fumes est de " & F_ef & " m"
        Select Case Regle
            Case 1
                'Calcul pour locaux de superficie infrieure ou gale  1000m
                If R200 = True Then
                    p(4) = "Le calcul a t effectu par la rgle du 1/200, le calcul de la SUE par la limitation" & _
                    "  1000m et suivant coefficient alpha n'ayant pas t plus restrictive."
                Else
                    p(4) = "Le calcul a t effectu par la rgle du 1/200 et compar au calcul de la SUE avec surface du canton" & _
                            "port  1000m et suivant coefficient alpha. Ce dernier calcul indiquant une SUE infrieure  celle dtermin par la " & _
                            "rgle du 1/200, la SUE retenue est donc la plus petite conformment  la rgle de l'IT 246."
                End If

            Case 2
                'Calcul pour locaux de superficie suprieure  1000m
                p(4) = "Le coefficient alpha est gal  " & F_alpha
        End Select
        p(5) = "La surface gomtrique totale d'exutoire pour un coefficient araulique K = " & F_k & " est gale  " & F_Slibre & " m."
        pp = p(1) + vbCrLf + p(2) + vbCrLf + p(3) + vbCrLf + p(4) + vbCrLf + p(5)
        Text1.Text = pp
    End Sub
   
End Class
