Imports System.Math
Public Class frmDesenfumageMecanique
    Dim R1, R2 As Boolean
    Dim H, Larg, Longueur, Dh As Double


#Region "Gestion des TextBox"
    Private Sub Texth_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextH.Enter
        TextH.SelectionStart = 0
        TextH.SelectionLength = TextH.Text.Length
    End Sub
    Private Sub Texth_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextH.KeyPress
        Call Gestion_Keypress(e, TextH)
    End Sub
    Private Sub Texthl_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Textlarg.Enter
        Textlarg.SelectionStart = 0
        Textlarg.SelectionLength = Textlarg.Text.Length
    End Sub
    Private Sub Textlarg_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Textlarg.KeyPress
        Call Gestion_Keypress(e, Textlarg)
    End Sub
    Private Sub Textlong_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextLong.Enter
        TextLong.SelectionStart = 0
        TextLong.SelectionLength = TextLong.Text.Length
    End Sub
    Private Sub Texts_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles TextLong.KeyPress
        Call Gestion_Keypress(e, TextLong)
    End Sub

#End Region

    Private Sub BtnCalcul_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnCalcul.Click
        Dim Verif As Boolean = True
        Call Lecture(Verif)
        If Verif = False Then Text1.Text = "" : Exit Sub
        Call Verification_generale(Verif)
        If Verif = False Then Text1.Text = "" : Exit Sub
        Call Calcul()
        Call Affichage()
    End Sub
    Private Sub Lecture(ByVal verif As Boolean)
        Dim msg As String
        If TextH.Text = "" Then
            msg = "Vous avez oubli d'indiquer la hauteur du canton"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            verif = False : Exit Sub
        Else
            H = CDbl(TextH.Text)
        End If
        If Textlarg.Text = "" Then
            msg = "Vous avez oubli d'indiquer la largeur du canton"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            verif = False : Exit Sub
        Else
            Larg = CDbl(Textlarg.Text)
        End If
        If TextLong.Text = "" Then
            msg = "Vous avez oubli d'indiquer la longueur du canton"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            verif = False : Exit Sub
        Else
            Longueur = CDbl(TextLong.Text)
        End If

    End Sub
    Private Sub Verification_generale(ByVal verif As Boolean)
        Dim msg As String
        If Longueur > 60 Then
            msg = "La longueur du canton est suprieure  60 m ce qui" & vbCrLf & _
            "ne respecte pas les prescriptions de l'IT 246." & vbCrLf & _
            "Veuillez modifiez la dimension !"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            verif = False : Exit Sub
        End If
        If Larg > 60 Then
            msg = "La longueur du canton est suprieure  60 m ce qui" & vbCrLf & _
            "ne respecte pas les prescriptions de l'IT 246." & vbCrLf & _
            "Veuillez modifiez la dimension !"
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
            verif = False : Exit Sub
        End If
    End Sub
    Private Sub Calcul()
        Dim Dh1, S, U, Vol As Double
        R2 = False : R1 = False
        Vol = H * Longueur * Larg
        Dh = 12 * Vol
        If Dh < 1.5 * 3600 Then Dh = 1.5 * 3600 : R1 = True
        S = Longueur * Larg
        U = S / 100
        If U = Int(S / 100) Then
            Dh1 = 3 * 3600 * U
        Else
            U = Int(U) + 1
            Dh1 = 3 * 3600 * U
        End If
        If Dh > Dh1 Then Dh = Dh1 : R2 = True
    End Sub
    Private Sub Affichage()
        Dim pp, p(10), F_Dh As String
        F_Dh = Format(Dh, "#####0.0#") 
        p(1) = "Le dbit horaire d'extraction du canton sera de " & F_Dh & " m3/h."
        If R2 = True Then
            p(2) = "Le dbit a t limit  3 m3/s par tranche de 100m de surface de local."
        Else
            If R1 = True Then
                p(2) = "Le dbit a t port  1,5 m3/s, le dbit de 12 volume/heure du local tant insuffisant suivant " & _
                "les prescriptions de l'IT 246."
            Else
                p(2) = "Le dbit horaire a t calcul suivant la rgle gnrale de 12 volume/heure"
            End If
        End If
        pp = p(1) + vbCrLf + p(2)
        Text1.Text = pp
    End Sub
End Class